--- sys/geom/raid5/g_raid5.c	2010-09-26 15:39:22.000000000 -0400
+++ /home/arne/sys/geom/raid5/g_raid5.c	2008-07-29 09:58:03.000000000 -0400
@@ -2012,11 +2012,7 @@
 	wakeup(&sc->term);
 
 	curthread->td_pflags &= ~TDP_GEOM;
-#if __FreeBSD_version >= 800000
-	kproc_exit(0);
-#else
 	kthread_exit(0);
-#endif
 }
 
 static __inline void
@@ -2158,10 +2154,9 @@
 		if (now.sec - lst_rrq.sec > g_raid5_tooc)
 			break;
 	}
-	if (sc->sc_rootmount != NULL) {
-		root_mount_rel(sc->sc_rootmount);
-		sc->sc_rootmount = NULL;
-	}
+	MYKASSERT(sc->sc_rootmount != NULL, ("why-oh-why???"));
+	root_mount_rel(sc->sc_rootmount);
+	sc->sc_rootmount = NULL;
 	if (!sc->term) {
 		g_topology_lock();
 		g_raid5_check_and_run(sc, 1);
@@ -2446,11 +2441,7 @@
 	wakeup(sc);
 
 	curthread->td_pflags &= ~TDP_GEOM;
-#if __FreeBSD_version >= 800000
-	kproc_exit(0);
-#else
 	kthread_exit(0);
-#endif
 }
 
 /*
@@ -2641,21 +2632,12 @@
 	sc->sc_type = type;
 
 	sc->term = 0;
-#if __FreeBSD_version >= 800000
-	if (kproc_create(g_raid5_worker, sc, &sc->worker, 0, 0,
-			 "g_raid5/main %s", md->md_name) != 0) {
-		sc->workerD = NULL;
-		sc->worker = NULL;
-	} else if (kproc_create(g_raid5_workerD, sc, &sc->workerD, 0, 0,
-				"g_raid5/done %s", md->md_name) != 0) {
-#else
 	if (kthread_create(g_raid5_worker, sc, &sc->worker, 0, 0,
-			 "g_raid5/main %s", md->md_name) != 0) {
+							 "g_raid5/main %s", md->md_name) != 0) {
 		sc->workerD = NULL;
 		sc->worker = NULL;
 	} else if (kthread_create(g_raid5_workerD, sc, &sc->workerD, 0, 0,
-				"g_raid5/done %s", md->md_name) != 0) {
-#endif
+							 "g_raid5/done %s", md->md_name) != 0) {
 		sc->workerD = NULL;
 		sc->term = 1;
 	}
